package com.alterdekim.game.controller.result.async;

import com.alterdekim.game.entity.Miniquest;
import com.alterdekim.game.entity.Preloader;
import com.alterdekim.game.entity.Promotion;
import com.alterdekim.game.entity.PromotionBanner;
import com.alterdekim.game.xml.CryptoSerializer;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonRootName;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlElementWrapper;
import com.fasterxml.jackson.dataformat.xml.annotation.JacksonXmlProperty;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.List;

@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonRootName(value = "response")
public class ServerActionResult {

    @JsonProperty
    private SnStatus sn_status;

    @JsonProperty
    private UserName user_name;

    @JsonProperty
    private List<Preloader> preloader;

    @JsonProperty
    private Flags flags;

    @JacksonXmlProperty(localName = "tutorial")
    @JacksonXmlElementWrapper(useWrapping = true, localName = "tutorial")
    private List<Tutorial> tutorial;

    @JsonProperty
    private Grants grants;

    @JsonProperty
    private Grants requests;

    @JsonProperty
    private List<Promotion> promotion;

    @JsonProperty
    private List<PromotionBanner> promotion_banner;

    @JsonProperty
    private PhoneMessages phone;

    @JsonProperty
    private PostcardMessages postcard;

    @JsonProperty
    @JacksonXmlElementWrapper(useWrapping = true, localName = "miniquest")
    private List<Miniquest> miniquest;

    @JacksonXmlProperty(localName = "cdata")
    @JsonSerialize(using = CryptoSerializer.class)
    @JacksonXmlElementWrapper(useWrapping = false, localName = "cdata")
    private List<ServerActionCData> cdata;
}